"""
Euclid_tm_types = {
    (1,1)   : 'TM-ACCEPT-REPORT-SUC (1,1)',
    (1,2)   : 'TM-ACCEPT-REPORT-FAIL (1,2)',
    (1,7)   : 'TM-EXEC-REPORT-SUC (1,7)',
    (1,8)   : 'TM-EXEC-REPORT-FAIL (1,8)',
    (3,10)  : 'TM-HK-PARAM-DEF-REPORT (3,10)',
    (3,12)  : 'TM-DIAG-PARAM-DEF-REPORT (3,12)',
    (3,25)  : 'TM-HK-PARAM-REPORT (3,25)',
    (3,26)  : 'TM-DIAG-PARAM-REPORT (3,26)',
    (3,136) : 'TM-ENAB-HK-REP (3,136)',
    (3,138) : 'TM-ENAB-DIAG-REP (3,138)',
    (5,1)   : 'TM-EVENT-NORMAL (5,1)',
    (5,2)   : 'TM-EVENT-LOW-ERROR (5,2)',
    (5,3)   : 'TM-EVENT-MED-ERROR (5,3)',
    (5,4)   : 'TM-EVENT-HIGH-ERROR (5,4)',
    (6,6)   : 'TM-MEMORY-DUMP-REPORT (6,6)',
    (6,10)  : 'TM-MEMORY-CHECK-REPORT (6,10)',
    (8,133) : 'TM-FUNCTION-PARAMETERS-REPORT (8,133)'
}
"""
Euclid_tm_types = {
    (1,1)   : '(1,1)   TM-ACCEPT-REPORT-SUC',
    (1,2)   : '(1,2)   TM-ACCEPT-REPORT-FAIL',
    (1,7)   : '(1,7)   TM-EXEC-REPORT-SUC ',
    (1,8)   : '(1,8)   TM-EXEC-REPORT-FAIL',
    (3,10)  : '(3,10)  TM-HK-PARAM-DEF-REPORT',
    (3,12)  : '(3,12)  TM-DIAG-PARAM-DEF-REPORT',
    (3,25)  : '(3,25)  TM-HK-PARAM-REPORT',
    (3,26)  : '(3,26)  TM-DIAG-PARAM-REPORT',
    (3,136) : '(3,136) TM-ENAB-HK-REP',
    (3,138) : '(3,138) TM-ENAB-DIAG-REP',
    (5,1)   : '(5,1)   TM-EVENT-NORMAL ',
    (5,2)   : '(5,2)   TM-EVENT-LOW-ERROR',
    (5,3)   : '(5,3)   TM-EVENT-MED-ERROR',
    (5,4)   : '(5,4)   TM-EVENT-HIGH-ERROR',
    (6,6)   : '(6,6)   TM-MEMORY-DUMP-REPORT',
    (6,10)  : '(6,10)  TM-MEMORY-CHECK-REPORT',
    (8,133) : '(8,133) TM-FUNCTION-PARAMETERS-REPORT'
}

Euclid_tm_types_alt = {
    0x0101 : 'TM-ACCEPT-REPORT-SUC',
    0x0102 : 'TM-ACCEPT-REPORT-FAIL',
    0x0107 : 'TM-EXEC-REPORT-SUC',
    0x0108 : 'TM-EXEC-REPORT-FAIL',
    0x030A : 'TM-HK-PARAM-DEF-REPORT',
    0x030C : 'TM-DIAG-PARAM-DEF-REPORT',
    0x0319 : 'TM-HK-PARAM-REPORT',
    0x031A : 'TM-DIAG-PARAM-REPORT',
    0x0388 : 'TM-ENAB-HK-REP',
    0x038A : 'TM-ENAB-DIAG-REP',
    0x0501 : 'TM-EVENT-NORMAL',
    0x0502 : 'TM-EVENT-LOW-ERROR',
    0x0503 : 'TM-EVENT-MED-ERROR',
    0x0504 : 'TM-EVENT-HIGH-ERROR',
    0x0606 : 'TM-MEMORY-DUMP-REPORT',
    0x060A : 'TM-MEMORY-CHECK-REPORT',
    0x0885 : 'TM-FUNCTION-PARAMETERS-REPORT'
}

type_1_2_error_codes = {
    0x0000 : 'ILLEGAL_APID',
    0x0001 : 'INVALID_LENGTH',
    0x0002 : 'INVALID_CRC',
    0x0003 : 'ILLEGAL_PACKET_TYPE',
    0x0004 : 'ILLEGAL_PACKET_SUBTYPE',
    0x0005 : 'ILLEGAL_PACKET_HEADER',
    0x0006 : 'ILLEGAL_SID',
    0x0007 : 'ILLEGAL_INTV',
    0x0008 : 'ILLEGAL_NPAR',
    0x0009 : 'ILLEGAL_Param_ID',
    0x000A : 'ILLEGAL_HK_APID',
    0x000B : 'ILLEGAL_EID',
    0x000C : 'ILLEGAL_MID',
    0x000D : 'ILLEGAL_NSEG',
    0x000E : 'ILLEGAL_START_ADD',
    0x000F : 'ILLEGAL_NSAU',
    0x0010 : 'ILLEGAL_FID',
    0x0011 : 'ILLEGAL_DATA_LEN',
    0x0012 : 'ILLEGAL_PARAM',
    0x0013 : 'ILLEGAL_REQ_OPER',
    0x0014 : 'ILLEGAL_NREP',
    0x001C : 'ILLEGAL_NPAR2'
    }

type_1_8_error_codes = {
    0x0015 : 'SCIENCE_OPER_ABORTED',
    0x0016 : 'MEMORY_READ_ERR',
    0x0017 : 'MODE_TRANS_NOT_ALLOWED',
    0x0018 : 'TRANS_REQ_NOT-ARMED',
    0x0019 : 'WAIT_READOUT_ERROR',
    0x001A : 'SUBSYSTEM_CMD_ERR',
    0x001B : 'MPS_BOARD_ERR',
    0x001E : 'PMCU_INIT_ERR',
    0x001F : 'MEM_WRITE_ERR',
    0x0020 : 'ROE_NOT_CONNECTED_ERR',
    0x0021 : 'PMCU_NOT_CONNECTED_ERR',
    0x0022 : 'MUX_BOARD_ERR',
    0x0023 : 'LCL_ERR',
    0x0024 : 'MMU_LINK_ERR',
    0x0025 : 'RSU_MOVE_ERR',
    0x0026 : 'DAT_HK_ERR',
    0x0027 : 'INTERNAL_ERR',
    0x0028 : 'RSU_MODE_ERR'
    }

hk_sid_table = {
    0 : 'ERROR!!!',
    1  : 'BSW_HK_RPT',
    2  : 'RT_SLOW_HK',
    3  : 'ST_SLOW_HK',
    4  : 'RT_FAST_HK',
    5  : 'RT_SUFAST_HK',
    6  : 'ST_SUFAST_HK',
    7  : 'SIN_PMCU_HK',
    8  : 'SIN_ROE_HK',
    9  : 'SIN_CDPU_HK',
    10 : 'ALL_PMCU_HK',
    11 : 'ALL_ROE_HK',
    12 : 'ALL_CDPU_HK',
    13 : 'RSU_TRAJ_REP',
    14 : 'RSU_VALSINE_REP',
    15 : 'CDPU_REG_VALUE',
    16 : 'LONG_PMCU_HK',
    17 : 'ROE_CMD_REP',
    18 : 'PMCU_CMD_REP',
    19 : 'ROE_HK_LIM_REP',
    20 : 'PMCU_HK_LIM_REP',
    21 : 'CDPU_HK_LIM_REP',
    22 : 'RSU_SH_TRAJ_REP'
}

bsw_event_codes = {
    0x0000 : 'ERROR!!!',
    0x0001 : 'VIS_BSW_ready_event',
    0x0002 : 'VIS_BUI_IN_Test_failure',
    0x0003 : 'VIS_SUROM_test_failure',
    0x0004 : 'VIS_RAM_Test_failure',
    0x0005 : 'VIS_EEPROM_Test_failure'    
    }

tm_event_codes = {
#    1 : tm_event_normal_codes,
#    2 : tm_event_low_error_codes,
#    3 : tm_event_med_error_codes,
#    4 : tm_event_high_error_codes
    0 : '0?',
    1 : '1?',
    0x0009 : 'VIS-READY-EVENT',
    0x000A : 'VIS-LIN-STEP1-EVENT',
    0x000B : 'VIS-LIN-STEP2-EVENT',
    0x000C : 'VIS-LIN-STEP3-EVENT',
    0x000D : 'VIS-LIN-STEP4-EVENT',
    0x000E : 'VIS-LED-ON-EVENT',
    0x000F : 'VIS-LED-OFF-EVENT  ',
    0x0010 : 'VIS SYNC PULSE',
    0x0011 : 'VIS-START-FLUSH-CCD',
    0x0012 : 'VIS-FLUSH-CCD',
    0x0013 : 'VIS-END-READOUT-CCD',
    0x0014 : 'PMCU-START-INIT',
    0x0015 : 'PMCU-END-INIT',
    0x0016 : 'START-IDLE',
    0x0017 : 'START-COMPRESSION',
    0x0018 : 'END-COMPRESSION',
    0x001A : 'VIS-START-CHARGE-INJ',
    0x001B : 'VIS-STOP-CHARGE-INJ',
    0x001C : 'VIS-START-TRAP-PUMP',
    0x001D : 'VIS-STOP-TRAP-PUMP',
    0x001E : 'VIS-START-OPEN-SHUTTER',
    0x001F : 'VIS-SHUTTER-OPEN',
    0x0020 : 'VIS-START-CLOSE-SHUTTER',
    0x0021 : 'VIS-SHUTTER-CLOSED',
    0x0022 : 'VIS-PARAM-WITHIN-RANGE',
    0x0023 : 'VIS-ERR-TO-NORMAL',
    0x0025 : 'ARM-COMMAND-EXPIRED',
    0x0026 : 'PMCU-ACK-NOT-RECEIVED',
    0x0027 : 'ROE-ACK-NOT-RECEIVED',
    0x0028 : 'ROE-ACK-ERROR',
    0x0029 : 'ROE-REPLY-NOT-RECEIVED',
    0x002A : 'ROE-REPLY-ERROR',
    0x002B : 'PMCU-ACK-ERROR',
    0x002C : 'PMCU-REPLY-ERROR',
    0x002D : 'PMCU-REPLY-NOT-REC',
    0x002E : 'PMCU-CRC-ERROR',
    0x0030 : 'ROE-READOUT-ERROR',
    0x0031 : 'ROE-READOUT-TIMEOUT',
    0x0032 : 'ROE-LINK-ERROR',
    0x0034 : 'RSU-POSITION-UNCHANGED',
    0x0035 : 'RSU-NOT-COMPLETELY-CLOSED',
    0x0036 : 'RSU-NOT-COMPLETELY-OPEN',
    0x0037 : 'PMCU-OOL-DETECTED',
    0x003B : 'ROE-OOL-DETECTED',
    0x0041 : 'PMCU-LINK-ERROR',
    0x003F : 'COMPRESSION-OVERRUN',
    0x0040 : 'MMU-LINK-ERROR',
    0x0051 : 'POWER-ON-RPSU1_REQUEST',
    0x0052 : 'POWER-ON-RPSU2_REQUEST',
    0x0053 : 'POWER-ON-RPSU3_REQUEST',
    0x0054 : 'POWER-ON-RPSU4_REQUEST',
    0x0055 : 'POWER-ON-RPSU5_REQUEST',
    0x0056 : 'POWER-ON-RPSU6_REQUEST',
    0x0057 : 'POWER-ON-RPSU7_REQUEST',
    0x0058 : 'POWER-ON-RPSU8_REQUEST',
    0x0059 : 'POWER-ON-RPSU9_REQUEST',
    0x005A : 'POWER-ON-RPSU10_REQUEST',
    0x005B : 'POWER-ON-RPSU11_REQUEST',
    0x005C : 'POWER-ON-RPSU12_REQUEST',
    0x005D : 'POWER-ON-ALL-RPSU',
    0x0061 : 'POWER-OFF-RPSU1_REQUEST',
    0x0062 : 'POWER-OFF-RPSU2_REQUEST',
    0x0063 : 'POWER-OFF-RPSU3_REQUEST',
    0x0064 : 'POWER-OFF-RPSU4_REQUEST',
    0x0065 : 'POWER-OFF-RPSU5_REQUEST',
    0x0066 : 'POWER-OFF-RPSU6_REQUEST',
    0x0067 : 'POWER-OFF-RPSU7_REQUEST',
    0x0068 : 'POWER-OFF-RPSU8_REQUEST',
    0x0069 : 'POWER-OFF-RPSU9_REQUEST',
    0x006A : 'POWER-OFF-RPSU10_REQUEST',
    0x006B : 'POWER-OFF-RPSU11_REQUEST',
    0x006C : 'POWER-OFF-RPSU12_REQUEST',
    0x006D : 'POWER-OFF-ALL-RPSU',
    0x0042 : 'EEPROM-EDAC-UNC-ERROR',
    0x0046 : 'AUTO-STANDBY-MODE',
    0x0047 : 'AUTO-PARKED-MODE',
    0x0048 : 'AUTO-SAFE-MODE',
    0x0049 : 'EEPROM-CONFIG-TABLES-CORRUPTED',
    0x004A : 'DAT-BOARD-ERROR',
    0x004C : 'CDPU-OOL-DETECTED'    
    }

tm_event_normal_codes = {
    0x0009 : 'VIS-READY-EVENT',
    0x000A : 'VIS-LIN-STEP1-EVENT',
    0x000B : 'VIS-LIN-STEP2-EVENT',
    0x000C : 'VIS-LIN-STEP3-EVENT',
    0x000D : 'VIS-LIN-STEP4-EVENT',
    0x000E : 'VIS-LED-ON-EVENT',
    0x000F : 'VIS-LED-OFF-EVENT  ',
    0x0010 : 'VIS SYNC PULSE',
    0x0011 : 'VIS-START-FLUSH-CCD',
    0x0012 : 'VIS-FLUSH-CCD',
    0x0013 : 'VIS-END-READOUT-CCD',
    0x0014 : 'PMCU-START-INIT',
    0x0015 : 'PMCU-END-INIT',
    0x0016 : 'START-IDLE',
    0x0017 : 'START-COMPRESSION',
    0x0018 : 'END-COMPRESSION',
    0x001A : 'VIS-START-CHARGE-INJ',
    0x001B : 'VIS-STOP-CHARGE-INJ',
    0x001C : 'VIS-START-TRAP-PUMP',
    0x001D : 'VIS-STOP-TRAP-PUMP',
    0x001E : 'VIS-START-OPEN-SHUTTER',
    0x001F : 'VIS-SHUTTER-OPEN',
    0x0020 : 'VIS-START-CLOSE-SHUTTER',
    0x0021 : 'VIS-SHUTTER -CLOSED',
    0x0022 : 'VIS-PARAM-WITHIN-RANGE',
    0x0023 : 'VIS-ERR-TO-NORMAL'
    }

tm_event_low_error_codes = {
    0x0025 : 'ARM-COMMAND-EXPIRED',
    0x0026 : 'PMCU-ACK-NOT-RECEIVED',
    0x0027 : 'ROE-ACK-NOT-RECEIVED',
    0x0028 : 'ROE-ACK-ERROR',
    0x0029 : 'ROE-REPLY-NOT-RECEIVED',
    0x002A : 'ROE-REPLY-ERROR',
    0x002B : 'PMCU-ACK-ERROR',
    0x002C : 'PMCU-REPLY-ERROR',
    0x002D : 'PMCU-REPLY-NOT-REC',
    0x002E : 'PMCU-CRC-ERROR',
    0x0030 : 'ROE-READOUT-ERROR',
    0x0031 : 'ROE-READOUT-TIMEOUT',
    0x0032 : 'ROE-LINK-ERROR',
    0x0034 : 'RSU-POSITION-UNCHANGED',
    0x0035 : 'RSU-NOT-COMPLETELY-CLOSED',
    0x0036 : 'RSU-NOT-COMPLETELY-OPEN',
    0x0037 : 'PMCU-OOL-DETECTED',
    0x003B : 'ROE-OOL-DETECTED',
    0x0041 : 'PMCU-LINK-ERROR'
    }

tm_event_med_error_codes = {
    0x003F : 'COMPRESSION-OVERRUN',
    0x0040 : 'MMU-LINK-ERROR',
    0x0051 : 'POWER-ON-RPSU1_REQUEST',
    0x0052 : 'POWER-ON-RPSU2_REQUEST',
    0x0053 : 'POWER-ON-RPSU3_REQUEST',
    0x0054 : 'POWER-ON-RPSU4_REQUEST',
    0x0055 : 'POWER-ON-RPSU5_REQUEST',
    0x0056 : 'POWER-ON-RPSU6_REQUEST',
    0x0057 : 'POWER-ON-RPSU7_REQUEST',
    0x0058 : 'POWER-ON-RPSU8_REQUEST',
    0x0059 : 'POWER-ON-RPSU9_REQUEST',
    0x005A : 'POWER-ON-RPSU10_REQUEST',
    0x005B : 'POWER-ON-RPSU11_REQUEST',
    0x005C : 'POWER-ON-RPSU12_REQUEST',
    0x005D : 'POWER-ON-ALL-RPSU',
    0x0061 : 'POWER-OFF-RPSU1_REQUEST',
    0x0062 : 'POWER-OFF-RPSU2_REQUEST',
    0x0063 : 'POWER-OFF-RPSU3_REQUEST',
    0x0064 : 'POWER-OFF-RPSU4_REQUEST',
    0x0065 : 'POWER-OFF-RPSU5_REQUEST',
    0x0066 : 'POWER-OFF-RPSU6_REQUEST',
    0x0067 : 'POWER-OFF-RPSU7_REQUEST',
    0x0068 : 'POWER-OFF-RPSU8_REQUEST',
    0x0069 : 'POWER-OFF-RPSU9_REQUEST',
    0x006A : 'POWER-OFF-RPSU10_REQUEST',
    0x006B : 'POWER-OFF-RPSU11_REQUEST',
    0x006C : 'POWER-OFF-RPSU12_REQUEST',
    0x006D : 'POWER-OFF-ALL-RPSU'
    }

tm_event_high_error_codes = {
    0x0042 : 'EEPROM-EDAC-UNC-ERROR',
    0x0046 : 'AUTO-STANDBY-MODE',
    0x0047 : 'AUTO-PARKED-MODE',
    0x0048 : 'AUTO-SAFE-MODE',
    0x0049 : 'EEPROM-CONFIG-TABLES-CORRUPTED',
    0x004A : 'DAT-BOARD-ERROR',
    0x004C : 'CDPU-OOL-DETECTED'
    }

